#pragma once

#include "afxcmn.h"
#include "DetailBoardNetworkDlg.h"
#include "DetailBoardThreadDlg.h"
#include "DetailBoardURLDlg.h"
#include "DetailBoardMessageDlg.h"



// CDetailBoardDlg _CAO

class CDetailBoardDlg : public CDialog
{
	DECLARE_DYNAMIC(CDetailBoardDlg)

public:
	CDetailBoardDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~CDetailBoardDlg();

// _CAO f[^
	enum { IDD = IDD_DETAIL_BOARD };

	int select_;

	struct Dialog {
		Dialog(sl::BoardConfig& board)
			: network(board)
			, thread(board)
			, url(board)
			, message(board)
		{}

		CDetailBoardNetworkDlg network;
		CDetailBoardThreadDlg thread;
		CDetailBoardURLDlg url;
		CDetailBoardMessageDlg message;
	};

	Dialog dlg_;

	struct Item {
		Item() : dlg(NULL), index(0), init([](){}) {}

		CDialog* dlg;
		int index;
		boost::function<void()> init;
	};

	std::vector<Item> vec_;

	sl::BoardConfig board_;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult);

	CTabCtrl m_xcTab;
};
