#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#include "TemplateListCtrl.h"

// CDetailBoardMessageDlg _CAO

class CDetailBoardMessageDlg : public CDialog
{
	DECLARE_DYNAMIC(CDetailBoardMessageDlg)

public:
	//CDetailBoardMessageDlg(CWnd* pParent = NULL);   // WRXgN^[
	CDetailBoardMessageDlg(sl::BoardConfig& board);
	virtual ~CDetailBoardMessageDlg();

	void InitControls();
	void EnableControls(BOOL enable);

// _CAO f[^
	enum { IDD = IDD_DETAIL_BOARD_MESSAGE };

	sl::BoardConfig& board_;
	utl::ReplaceElementList list_;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBtnAdd();
	afx_msg void OnBnClickedBtnDel();
	afx_msg void OnBnClickedBtnUp();
	afx_msg void OnBnClickedBtnDown();
	afx_msg void OnEnChangeEditDesc();
	afx_msg void OnEnChangeEditRegex();
	afx_msg void OnEnChangeEditFormat();
	afx_msg void OnBnClickedBtnAllDefault();

	CTemplateListCtrl m_xcList;
	CEdit m_xcEditDesc;
	CEdit m_xcEditRegex;
	CEdit m_xcEditFormat;
};
