#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "ChannelSampleView.h"
#include "ColorButton.h"
#include "FontButton.h"
#include "templatecombobox.h"

// CDisplayChannelDlg _CAO

class CDisplayChannelDlg : public CDialog
{
	DECLARE_DYNAMIC(CDisplayChannelDlg)

public:
	CDisplayChannelDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~CDisplayChannelDlg();

	void InitControls();
	void OnBnClickedBtnColor(int index);
	void OnBnClickedBtnText(int index);

// _CAO f[^
	enum { IDD = IDD_DISPLAY_CHANNEL };

	sl::ChannelConfig channel_;
	std::vector<sl::ChannelPair> custom_;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClickedBtnColor1();
	afx_msg void OnBnClickedBtnColor2();
	afx_msg void OnBnClickedBtnColor3();
	afx_msg void OnBnClickedBtnColor4();
	afx_msg void OnBnClickedBtnColor5();
	afx_msg void OnBnClickedBtnColor6();
	afx_msg void OnBnClickedBtnText1();
	afx_msg void OnBnClickedBtnFont();
	afx_msg void OnEnChangeEditMarginX();
	afx_msg void OnEnChangeEditMarginY();
	afx_msg void OnBnClickedCheckOpaque();
	afx_msg void OnEnChangeEditOpaqueText();
	afx_msg void OnEnChangeEditOpaqueBack();
	afx_msg void OnBnClickedBtnSample();
	afx_msg void OnBnClickedBtnAllDefault();
	afx_msg void OnBnClickedBtnAdd();
	afx_msg void OnBnClickedBtnDel();
	afx_msg void OnCbnSelchangeCmbCustom();
	afx_msg void OnDestroy();

	CChannelSampleView m_xcSample;
	CColorButton m_xcBtnColor[6];
	
	CColorButton m_xcBtnText[1];
	CFontButton m_xcBtnFont;

	CEdit m_xcEditMarginX;
	CSpinButtonCtrl m_xcSpinMarginX;
	CEdit m_xcEditMarginY;
	CSpinButtonCtrl m_xcSpinMarginY;

	CButton m_xcCheckOpaque;
	CEdit m_xcEditOpaqueText;
	CSpinButtonCtrl m_xcSpinOpaqueText;
	CEdit m_xcEditOpaqueBack;
	CSpinButtonCtrl m_xcSpinOpaqueBack;

	CTemplateComboBox m_xcCmbCustom;
};
