// DisplayWindowDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DisplayWindowDlg.h"
//#include "afxdialogex.h"

#define TOTAL_COUNT (30) // 

// CDisplayWindowDlg _CAO

IMPLEMENT_DYNAMIC(CDisplayWindowDlg, CDialog)

CDisplayWindowDlg::CDisplayWindowDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayWindowDlg::IDD, pParent)
	, orderZoom1_(false)
	, orderZoom2_(false)
	, orderSize1_(false)
	, orderSize2_(false)
{

}

CDisplayWindowDlg::~CDisplayWindowDlg()
{
}

void CDisplayWindowDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_ZOOM, m_xcListZoom);
	DDX_Control(pDX, IDC_BTN_ZOOM_ADD, m_xcBtnZoomAdd);
	DDX_Control(pDX, IDC_BTN_ZOOM_DEL, m_xcBtnZoomDel);
	DDX_Control(pDX, IDC_BTN_ZOOM_UP, m_xcBtnZoomUp);
	DDX_Control(pDX, IDC_BTN_ZOOM_DOWN, m_xcBtnZoomDown);
	DDX_Control(pDX, IDC_EDIT_ZOOM, m_xcEditZoom);
	DDX_Control(pDX, IDC_SPIN_ZOOM, m_xcSpinZoom);
	DDX_Control(pDX, IDC_LIST_SIZE, m_xcListSize);
	DDX_Control(pDX, IDC_BTN_SIZE_ADD, m_xcBtnSizeAdd);
	DDX_Control(pDX, IDC_BTN_SIZE_DEL, m_xcBtnSizeDel);
	DDX_Control(pDX, IDC_BTN_SIZE_UP, m_xcBtnSizeUp);
	DDX_Control(pDX, IDC_BTN_SIZE_DOWN, m_xcBtnSizeDown);
	DDX_Control(pDX, IDC_EDIT_SIZE1, m_xcEditSize1);
	DDX_Control(pDX, IDC_SPIN_SIZE1, m_xcSpinSize1);
	DDX_Control(pDX, IDC_EDIT_SIZE2, m_xcEditSize2);
	DDX_Control(pDX, IDC_SPIN_SIZE2, m_xcSpinSize2);
}


BEGIN_MESSAGE_MAP(CDisplayWindowDlg, CDialog)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_ZOOM, &CDisplayWindowDlg::OnLvnGetdispinfoListZoom)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_SIZE, &CDisplayWindowDlg::OnLvnGetdispinfoListSize)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_ZOOM, &CDisplayWindowDlg::OnLvnItemchangedListZoom)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_SIZE, &CDisplayWindowDlg::OnLvnItemchangedListSize)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST_ZOOM, &CDisplayWindowDlg::OnLvnColumnclickListZoom)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST_SIZE, &CDisplayWindowDlg::OnLvnColumnclickListSize)
	ON_NOTIFY(NM_CLICK, IDC_LIST_ZOOM, &CDisplayWindowDlg::OnNMClickListZoom)
	ON_NOTIFY(NM_CLICK, IDC_LIST_SIZE, &CDisplayWindowDlg::OnNMClickListSize)
	ON_EN_CHANGE(IDC_EDIT_ZOOM, &CDisplayWindowDlg::OnEnChangeEditZoom)
	ON_EN_CHANGE(IDC_EDIT_SIZE1, &CDisplayWindowDlg::OnEnChangeEditSize1)
	ON_EN_CHANGE(IDC_EDIT_SIZE2, &CDisplayWindowDlg::OnEnChangeEditSize2)
	ON_BN_CLICKED(IDC_BTN_ZOOM_ADD, &CDisplayWindowDlg::OnBnClickedBtnZoomAdd)
	ON_BN_CLICKED(IDC_BTN_SIZE_ADD, &CDisplayWindowDlg::OnBnClickedBtnSizeAdd)
	ON_BN_CLICKED(IDC_BTN_ZOOM_DEL, &CDisplayWindowDlg::OnBnClickedBtnZoomDel)
	ON_BN_CLICKED(IDC_BTN_SIZE_DEL, &CDisplayWindowDlg::OnBnClickedBtnSizeDel)
	ON_BN_CLICKED(IDC_BTN_ZOOM_UP, &CDisplayWindowDlg::OnBnClickedBtnZoomUp)
	ON_BN_CLICKED(IDC_BTN_SIZE_UP, &CDisplayWindowDlg::OnBnClickedBtnSizeUp)
	ON_BN_CLICKED(IDC_BTN_ZOOM_DOWN, &CDisplayWindowDlg::OnBnClickedBtnZoomDown)
	ON_BN_CLICKED(IDC_BTN_SIZE_DOWN, &CDisplayWindowDlg::OnBnClickedBtnSizeDown)
	ON_BN_CLICKED(IDC_BTN_ZOOM_ALL_DEFAULT, &CDisplayWindowDlg::OnBnClickedBtnZoomAllDefault)
	ON_BN_CLICKED(IDC_BTN_SIZE_ALL_DEFAULT, &CDisplayWindowDlg::OnBnClickedBtnSizeAllDefault)
END_MESSAGE_MAP()


// CDisplayWindowDlg bZ[W nh[
BOOL CDisplayWindowDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcListZoom.SetExtendedStyle(m_xcListZoom.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_INFOTIP|LVS_EX_DOUBLEBUFFER|LVS_EX_CHECKBOXES);
	m_xcListZoom.SetCallbackMask(LVIS_STATEIMAGEMASK);

	m_xcListSize.SetExtendedStyle(m_xcListSize.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_INFOTIP|LVS_EX_DOUBLEBUFFER|LVS_EX_CHECKBOXES);
	m_xcListSize.SetCallbackMask(LVIS_STATEIMAGEMASK);

	m_xcListZoom.InsertColumn(0, L"", LVCFMT_CENTER, 30);
	m_xcListZoom.InsertColumn(1, L"{", LVCFMT_LEFT, 120);

	m_xcListSize.InsertColumn(0, L"", LVCFMT_CENTER, 30);
	m_xcListSize.InsertColumn(1, L"TCY", LVCFMT_LEFT, 120);

	m_xcListZoom.SetItemCountEx(static_cast<int>(zoom_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListSize.SetItemCountEx(static_cast<int>(size_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	m_xcSpinZoom.SetRange32(10, 1000);
	m_xcSpinZoom.SetPos32(100);

	m_xcSpinSize1.SetRange32(16, 10000);
	m_xcSpinSize1.SetPos32(800);
	m_xcSpinSize2.SetRange32(16, 10000);
	m_xcSpinSize2.SetPos32(600);

	if (zoom_.size() > 0)
	{
		m_xcListZoom.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListZoom.EnsureVisible(0, FALSE);
	}
	else
	{
		m_xcEditZoom.EnableWindow(FALSE);
		m_xcSpinZoom.EnableWindow(FALSE);
	}

	if (size_.size() > 0)
	{
		m_xcListSize.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListSize.EnsureVisible(0, FALSE);
	}
	else
	{
		m_xcEditSize1.EnableWindow(FALSE);
		m_xcSpinSize1.EnableWindow(FALSE);
		m_xcEditSize2.EnableWindow(FALSE);
		m_xcSpinSize2.EnableWindow(FALSE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDisplayWindowDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDisplayWindowDlg::OnLvnGetdispinfoListZoom(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	if (!pDispInfo) { return; }
	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_STATE)
	{
		try {
			pDispInfo->item.state = LVIS_STATEIMAGEMASK;

			if (zoom_.at(i).enable) {
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(2);
			}
			else {
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(1);
			}
		} catch (...) {}
	}

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 1:
			{
				try {
					sl::WindowZoom x = zoom_.at(i);
					csLine.Format(L"%d%%", x.zoom);
				} catch (...) {}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult) { *pResult = 0; }
}


void CDisplayWindowDlg::OnLvnGetdispinfoListSize(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	if (!pDispInfo) { return; }
	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_STATE)
	{
		try {
			pDispInfo->item.state = LVIS_STATEIMAGEMASK;

			if (size_.at(i).enable) {
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(2);
			}
			else {
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(1);
			}
		} catch (...) {}
	}

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 1:
			{
				try {
					sl::WindowSize x = size_.at(i);
					csLine.Format(L"%dx%d", x.width, x.height);
				} catch (...) {}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult) { *pResult = 0; }
}


void CDisplayWindowDlg::OnLvnItemchangedListZoom(NMHDR *pNMHDR, LRESULT *pResult)
{
	int i = m_xcListZoom.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);

	if (i >= 0) // I
	{
		sl::WindowZoom x;
		try {
			x = zoom_.at(i);
		} catch(...) {}

		m_xcSpinZoom.SetPos32(x.zoom);
		m_xcEditZoom.EnableWindow(TRUE);
		m_xcSpinZoom.EnableWindow(TRUE);
	}
	else
	{
		m_xcEditZoom.EnableWindow(FALSE);
		m_xcSpinZoom.EnableWindow(FALSE);
	}

	if (pResult) { *pResult = 0; }
}


void CDisplayWindowDlg::OnLvnItemchangedListSize(NMHDR *pNMHDR, LRESULT *pResult)
{
	int i = m_xcListSize.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);

	if (i >= 0) // I
	{
		sl::WindowSize x;
		try {
			x = size_.at(i);
		} catch(...) {}

		m_xcSpinSize1.SetPos32(x.width);
		m_xcSpinSize2.SetPos32(x.height);
		m_xcEditSize1.EnableWindow(TRUE);
		m_xcSpinSize1.EnableWindow(TRUE);
		m_xcEditSize2.EnableWindow(TRUE);
		m_xcSpinSize2.EnableWindow(TRUE);
	}
	else
	{
		m_xcEditSize1.EnableWindow(FALSE);
		m_xcSpinSize1.EnableWindow(FALSE);
		m_xcEditSize2.EnableWindow(FALSE);
		m_xcSpinSize2.EnableWindow(FALSE);
	}

	if (pResult) { *pResult = 0; }
}

void CDisplayWindowDlg::OnLvnColumnclickListZoom(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (!pNMLV) { return; }

	switch(pNMLV->iSubItem)
	{
	case 0:
		std::stable_sort(zoom_.begin(), zoom_.end(),
			[this](const sl::WindowZoom& l, const sl::WindowZoom& r)->bool{
				if (!orderZoom1_ && l.enable && !r.enable) { return true; }
				if (orderZoom1_ && !l.enable && r.enable) { return true; }
				return false;
		});
		m_xcListZoom.RedrawWindow();
		orderZoom1_ = orderZoom1_ ? false : true;
		break;

	case 1:
		std::stable_sort(zoom_.begin(), zoom_.end(),
			[this](const sl::WindowZoom& l, const sl::WindowZoom& r)->bool{
				return orderZoom2_ ? l.zoom > r.zoom : l.zoom < r.zoom;
		});
		m_xcListZoom.RedrawWindow();
		orderZoom2_ = orderZoom2_ ? false : true;
		break;

	default:
		break;
	}

	OnLvnItemchangedListZoom(0, 0);

	if (pResult) { *pResult = 0; }
}


void CDisplayWindowDlg::OnLvnColumnclickListSize(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (!pNMLV) { return; }

	switch(pNMLV->iSubItem)
	{
	case 0:
		std::stable_sort(size_.begin(), size_.end(),
			[this](const sl::WindowSize& l, const sl::WindowSize& r)->bool{
				if (!orderSize1_ && l.enable && !r.enable) { return true; }
				if (orderSize1_ && !l.enable && r.enable) { return true; }
				return false;
		});
		m_xcListSize.RedrawWindow();
		orderSize1_ = orderSize1_ ? false : true;
		break;

	case 1:
		std::stable_sort(size_.begin(), size_.end(),
			[this](const sl::WindowSize& l, const sl::WindowSize& r)->bool{
				return orderSize2_ ? l.width * l.height > r.width * r.height : l.width * l.height < r.width * r.height;
		});
		m_xcListSize.RedrawWindow();
		orderSize2_ = orderSize2_ ? false : true;
		break;

	default:
		break;
	}

	OnLvnItemchangedListSize(0, 0);

	if (pResult) { *pResult = 0; }
}


void CDisplayWindowDlg::OnNMClickListZoom(NMHDR *pNMHDR, LRESULT *pResult)
{
	CPoint pt;
	::GetCursorPos(&pt);
	m_xcListZoom.ScreenToClient(&pt);

	LVHITTESTINFO lvHit;
	lvHit.pt = pt;
	int i = m_xcListZoom.SubItemHitTest(&lvHit);

	if (lvHit.iSubItem == 0 && lvHit.flags & LVHT_ONITEMSTATEICON)
	{
		try {
			zoom_.at(i).enable = zoom_.at(i).enable ? false : true;
		} catch (...) {}

		CRect rc;
		m_xcListZoom.GetItemRect(i, &rc, LVIR_BOUNDS);
		m_xcListZoom.InvalidateRect(&rc, FALSE);
	}

	if (pResult) { *pResult = 0; }
}


void CDisplayWindowDlg::OnNMClickListSize(NMHDR *pNMHDR, LRESULT *pResult)
{
	CPoint pt;
	::GetCursorPos(&pt);
	m_xcListSize.ScreenToClient(&pt);

	LVHITTESTINFO lvHit;
	lvHit.pt = pt;
	int i = m_xcListSize.SubItemHitTest(&lvHit);

	if (lvHit.iSubItem == 0 && lvHit.flags & LVHT_ONITEMSTATEICON)
	{
		try {
			size_.at(i).enable = size_.at(i).enable ? false : true;
		} catch (...) {}

		CRect rc;
		m_xcListSize.GetItemRect(i, &rc, LVIR_BOUNDS);
		m_xcListSize.InvalidateRect(&rc, FALSE);
	}

	if (pResult) { *pResult = 0; }
}


void CDisplayWindowDlg::OnEnChangeEditZoom()
{
	if (!IsWindow(m_xcListZoom.GetSafeHwnd())) { return; }

	int i = m_xcListZoom.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)zoom_.size()) { return; }

	if (!IsWindow(m_xcEditZoom.GetSafeHwnd())) { return; }

	zoom_.at(i).zoom = m_xcSpinZoom.GetPos32();
	m_xcListZoom.Update(i);
}


void CDisplayWindowDlg::OnEnChangeEditSize1()
{
	if (!IsWindow(m_xcListSize.GetSafeHwnd())) { return; }

	int i = m_xcListSize.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)size_.size()) { return; }

	if (!IsWindow(m_xcEditSize1.GetSafeHwnd())) { return; }

	size_.at(i).width = m_xcSpinSize1.GetPos32();
	m_xcListSize.Update(i);
}


void CDisplayWindowDlg::OnEnChangeEditSize2()
{
	if (!IsWindow(m_xcListSize.GetSafeHwnd())) { return; }

	int i = m_xcListSize.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)size_.size()) { return; }

	if (!IsWindow(m_xcEditSize2.GetSafeHwnd())) { return; }

	size_.at(i).height = m_xcSpinSize2.GetPos32();
	m_xcListSize.Update(i);
}


void CDisplayWindowDlg::OnBnClickedBtnZoomAdd()
{
	int size = (int)zoom_.size();
	// l葽ȂȂɂȂ
	if (size >= TOTAL_COUNT) { return; }

	zoom_.push_back(sl::WindowZoom(true, 100));

	m_xcListZoom.SetItemCountEx(static_cast<int>(zoom_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	int i = (int)zoom_.size();
	m_xcListZoom.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcListZoom.EnsureVisible(i - 1, FALSE);
	m_xcListZoom.RedrawWindow();
}


void CDisplayWindowDlg::OnBnClickedBtnSizeAdd()
{
	int size = (int)size_.size();
	// l葽ȂȂɂȂ
	if (size >= TOTAL_COUNT) { return; }

	size_.push_back(sl::WindowSize(true, 800, 600));

	m_xcListSize.SetItemCountEx(static_cast<int>(size_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	int i = (int)size_.size();
	m_xcListSize.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcListSize.EnsureVisible(i - 1, FALSE);
	m_xcListSize.RedrawWindow();
}


void CDisplayWindowDlg::OnBnClickedBtnZoomDel()
{
	int i = m_xcListZoom.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)zoom_.size()) { return; }

	try {
		auto it = zoom_.begin() + i;
		zoom_.erase(it);
		m_xcListZoom.SetItemCountEx((int)zoom_.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

		if ((int)zoom_.size() > i)
		{
			m_xcListZoom.SetItemState(i, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
			m_xcListZoom.EnsureVisible(i, FALSE);
		}
		else
		{
			m_xcEditZoom.EnableWindow(FALSE);
			m_xcSpinZoom.EnableWindow(FALSE);
		}
		m_xcListZoom.RedrawWindow();
	} catch (...) {}

	OnLvnItemchangedListZoom(0, 0);
}


void CDisplayWindowDlg::OnBnClickedBtnSizeDel()
{
	int i = m_xcListSize.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)size_.size()) { return; }

	try {
		auto it = size_.begin() + i;
		size_.erase(it);
		m_xcListSize.SetItemCountEx((int)size_.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

		if ((int)size_.size() > i)
		{
			m_xcListSize.SetItemState(i, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
			m_xcListSize.EnsureVisible(i, FALSE);
		}
		else
		{
			m_xcEditSize1.EnableWindow(FALSE);
			m_xcSpinSize1.EnableWindow(FALSE);
			m_xcEditSize2.EnableWindow(FALSE);
			m_xcSpinSize2.EnableWindow(FALSE);
		}
		m_xcListSize.RedrawWindow();
	} catch (...) {}

	OnLvnItemchangedListSize(0, 0);
}


void CDisplayWindowDlg::OnBnClickedBtnZoomUp()
{
	int i = m_xcListZoom.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)zoom_.size()) { return; }

	if (i <= 0) { return; }

	try {
		sl::WindowZoom x = zoom_.at(i - 1);
		zoom_.at(i - 1) = zoom_.at(i);
		zoom_.at(i) = x;

		m_xcListZoom.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListZoom.EnsureVisible(i - 1, FALSE);

		m_xcListZoom.RedrawWindow();
	} catch (...) {}
}


void CDisplayWindowDlg::OnBnClickedBtnSizeUp()
{
	int i = m_xcListSize.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)size_.size()) { return; }

	if (i <= 0) { return; }

	try {
		sl::WindowSize x = size_.at(i - 1);
		size_.at(i - 1) = size_.at(i);
		size_.at(i) = x;

		m_xcListSize.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListSize.EnsureVisible(i - 1, FALSE);

		m_xcListSize.RedrawWindow();
	} catch (...) {}
}


void CDisplayWindowDlg::OnBnClickedBtnZoomDown()
{
	int i = m_xcListZoom.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)zoom_.size()) { return; }

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (i >= (int)(zoom_.size() - 1)) { return; }

	try {
		sl::WindowZoom x = zoom_.at(i + 1);
		zoom_.at(i + 1) = zoom_.at(i);
		zoom_.at(i) = x;

		m_xcListZoom.SetItemState(i + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListZoom.EnsureVisible(i + 1, FALSE);

		m_xcListZoom.RedrawWindow();
	} catch (...) {}
}


void CDisplayWindowDlg::OnBnClickedBtnSizeDown()
{
	int i = m_xcListSize.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)size_.size()) { return; }

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (i >= (int)(size_.size() - 1)) { return; }

	try {
		sl::WindowSize x = size_.at(i + 1);
		size_.at(i + 1) = size_.at(i);
		size_.at(i) = x;

		m_xcListSize.SetItemState(i + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListSize.EnsureVisible(i + 1, FALSE);

		m_xcListSize.RedrawWindow();
	} catch (...) {}
}




void CDisplayWindowDlg::OnBnClickedBtnZoomAllDefault()
{
	sl::WindowConfig win;
	zoom_ = win.zoom;

	m_xcListZoom.SetItemCountEx(static_cast<int>(zoom_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	m_xcListZoom.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcListZoom.EnsureVisible(0, FALSE);
	m_xcListZoom.RedrawWindow();
}


void CDisplayWindowDlg::OnBnClickedBtnSizeAllDefault()
{
	sl::WindowConfig win;
	size_ = win.size;

	m_xcListSize.SetItemCountEx(static_cast<int>(size_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	m_xcListSize.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcListSize.EnsureVisible(0, FALSE);
	m_xcListSize.RedrawWindow();
}
